import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'dart:io' show Platform;
import 'conscent_initializer.dart';
import 'conscent_methods.dart';
import 'datamodel/api_mode.dart';
import 'datamodel/login_challengeget.dart';
import 'constants.dart';

class WebViewAppsss extends StatefulWidget {
  const WebViewAppsss({super.key,required this.controller});

  final WebViewController controller;

  @override
  State<WebViewAppsss> createState() => _WebViewAppState();
}

class _WebViewAppState extends State<WebViewAppsss> {
  String? loginId;
  // String? sessionId;

  bool showContent = false;
  bool isLoaded = false;
  var loadingPercentage = 0;
  // final sessionId = TextEditingController();

  @override
  void initState() {
    if (mounted) {
      getLoginChallengeId();
    }
    super.initState();

    widget.controller
      ..setNavigationDelegate(
        NavigationDelegate(
          onPageStarted: (url) {
            print(url);
            // setState(() {
            //   loadingPercentage = 0;
            // });
          },
          onProgress: (progress) {

            // setState(() {
            //   loadingPercentage = progress;
            // });
          },
          onPageFinished: (url) {
            print(url);
            // setState(() {
            //   loadingPercentage = 100;
            // });
          },
          // onNavigationRequest: (navigation) {
          //   final host = Uri.parse(navigation.url).host;
          //   if (host.contains('youtube.com')) {
          //     ScaffoldMessenger.of(context).showSnackBar(
          //       SnackBar(
          //         content: Text(
          //           'Blocking navigation to $host',
          //         ),
          //       ),
          //     );
          //     return NavigationDecision.prevent;
          //   }
          //   return NavigationDecision.navigate;
          // },
        ),
      ) // Modify from here...
      ..setJavaScriptMode(JavaScriptMode.unrestricted);

  }

  // dynamic dataMain;
  getLoginChallengeId() async {
    final prefs = await SharedPreferences.getInstance();
    loginId = prefs.getString('loginID');
    getSessionID(loginId.toString());
    setState(() {});
  }

  Future<String> getSessionID(String loginId) async {
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge/$loginId');

    var response = await http.get(uri);
    if (response.statusCode == 200) {
      LoginChallengeget loginChallengeget =
          loginChallengegetFromJson(response.body);
      final prefs = await SharedPreferences.getInstance();

      String sessionId = loginChallengeget.sessionId.toString();
      prefs.setString('sessionId', sessionId);
      CircularProgressIndicator();
      return sessionId;
    } else {
      ConscentMethods().onPluginError(response.body);
    }
    return '';
  }

  Future<void> submitDatas(
      String clientId, String clientContentId, String sessionId) async {
    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/content/access'), body: {
      "clientId": '${ConscentInitializer.mClientId}',
      "clientContentId": '${ConscentInitializer.mContentId}',
      "sessionId": sessionId,
    });

    if (response.statusCode == 201) {
      var responseString = response.body;
      Navigator.pop(context, {"response": responseString});
    } else {
      ConscentMethods().onPluginError(response.body);
    }
  }


  @override
  Widget build(BuildContext context) {
    return Stack(
      children: [
        WebViewWidget(
          controller: widget.controller..loadRequest(Uri.parse('${APIMode.SERVICE_BASE_URL}/overlay?purchaseMode=PASS&loginChallenge=$loginId&clientId=${ConscentInitializer.mClientId}&clientContentId=${ConscentInitializer.mContentId}')),
        )
      ],
    );
  }
}
