import 'dart:io' show Platform;


import 'package:flutter/material.dart';
import 'package:flutter_conscent_plugin/shared_pref.dart';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
import 'package:uuid/uuid.dart';
import 'package:webview_flutter/webview_flutter.dart';
import 'conscent_initializer.dart';
import 'conscent_methods.dart';
import 'constants.dart';
import 'datamodel/api_mode.dart';
import 'datamodel/auto_login_response.dart';
import 'datamodel/login_challenge_post.dart';

class WebViewLogin extends StatefulWidget {
  final String token;
  final String? phone;
  final String? email;
  const WebViewLogin({Key? key, required this.token, required this.phone, required this.email,required this.controller})
      : super(key: key);

  final WebViewController controller;

  @override
  State<WebViewLogin> createState() => _WebViewLoginState();
}

class _WebViewLoginState extends State<WebViewLogin> {
  String? loginId;
  // String? sessionId;
  var loadingPercentage = 0;

  bool showContent = false;
  bool isLoaded = false;

  @override
  void initState() {
    if (mounted) {
      _createAndGetLogInChallenge();
    }
    super.initState();

    widget.controller
      ..setNavigationDelegate(
        NavigationDelegate(
          onPageStarted: (url) {
            print(url);
            // setState(() {
            //   loadingPercentage = 0;
            // });
          },
          onProgress: (progress) {

            // setState(() {
            //   loadingPercentage = progress;
            // });
          },
          onPageFinished: (url) {
            print(url);
            // setState(() {
            //   loadingPercentage = 100;
            // });
          },
          // onNavigationRequest: (navigation) {
          //   final host = Uri.parse(navigation.url).host;
          //   if (host.contains('youtube.com')) {
          //     ScaffoldMessenger.of(context).showSnackBar(
          //       SnackBar(
          //         content: Text(
          //           'Blocking navigation to $host',
          //         ),
          //       ),
          //     );
          //     return NavigationDecision.prevent;
          //   }
          //   return NavigationDecision.navigate;
          // },
        ),
      )
      ..loadRequest(Uri.parse("${APIMode.SERVICE_BASE_URL}/auto-login-user?id=${widget.token}&clientId=${ConscentInitializer.mClientId}&phone=${widget.phone}&email=${widget.email}&loginChallengeId=$loginId"))
    // Modify from here...
      ..setJavaScriptMode(JavaScriptMode.unrestricted)
      ..addJavaScriptChannel(
        'AUTOLOGIN',
        onMessageReceived: (message) async {
          print("AUTOLOGIN autoLoginResponse ${message.message}");
          AutoLoginResponse autoLoginResponse = autoLoginResponseFromJson(message.message);
          print("AUTOLOGIN autoLoginResponse ${autoLoginResponse.toJson()}");

          final prefs = await SharedPreferences.getInstance();


          if(autoLoginResponse.status == true){
            Constants.logIn = true;
            String? sessionId = autoLoginResponse.sessionId;
            prefs.setString('sessionId', sessionId!);
            SharedPref().setUserId(autoLoginResponse.userId);
            Navigator.pop(context,{autoLoginResponse.userId, autoLoginResponse.status});
          }else{
            if(loginId != null){
              Navigator.pop(context,{autoLoginResponse.message, autoLoginResponse.status});
            }

          }
        },
      );
  }

  @override
  void dispose() {
    super.dispose();
  }

  Future<void> _createAndGetLogInChallenge() async {
    final prefs = await SharedPreferences.getInstance();
    loginId = prefs.getString('loginID');
    print('loginId = $loginId');
    var response;
    if(loginId == null){
      response = await http.post(Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge'), body: {
        "loginChallengeId": '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}',
        "redirectTo": ""
      });

      if (response.statusCode == 201) {
        var responseString = response.body;
        String loginChallengeId =
            loginChallengepostFromJson(responseString).loginChallengeId;
        final prefs = await SharedPreferences.getInstance();
        await prefs.setString('loginID', loginChallengeId);
        loginId =  loginChallengeId;
        print('loginId = $loginId');
        setState(() {});
      } else {
        ConscentMethods().onPluginError(response.body);
        throw Exception('Failed to create album.');
      }
    }else{

      setState(() {});
    }




  }


  @override
  Widget build(BuildContext context) {
    return Stack(
      children: [
        WebViewWidget(
          controller: widget.controller..loadRequest(Uri.parse("${APIMode.SERVICE_BASE_URL}/auto-login-user?id=${widget.token}&clientId=${ConscentInitializer.mClientId}&phone=${widget.phone}&email=${widget.email}&loginChallengeId=$loginId")),
        )
      ],
    );
  }
}
